#!/bin/bash
# This script will toggle on and off the asusg50oled program and the
# oled display.

# Check whether or not the asus_oled module is loaded, and if so, try to
# bring it up
lsmod | grep asus_oled 2> /dev/null 1>&2 

if [ $? != 0 ]; then

	modprobe asus_oled 2> /dev/null 1>&2 

	if [ $? != 0 ]; then
		echo ""$(date "+%b %d %H:%M:%S")" "$(uname -n)" acpid: The asus_oled module failed to load. Either it is not installed" >> /var/log/messages
		exit 1
	fi
fi

# Start the daemon in case it is not and make sure the display is enabled.
pgrep -f "jar leds.jar" &>/dev/null
if [ $? != 0 ]; then
	/usr/share/asusg50oled/start.sh
	echo 1 > /sys/class/asus_oled/oled_1/enabled 2> /dev/null 1>&2 
	exit
fi

OLED_STATUS="$(cat /sys/class/asus_oled/oled_1/enabled)"

if [ "$OLED_STATUS" == "1" ]; then
	echo 0 > /sys/class/asus_oled/oled_1/enabled
	echo "pause" | nc -n -w 5 127.0.0.1 1196 2> /dev/null 1>&2
else
	echo 1 > /sys/class/asus_oled/oled_1/enabled
	echo "resume" | nc -n -w 5 127.0.0.1 1196 2> /dev/null 1>&2
fi
