/**
 * 
 */
package leds;

/**
 * Interface that describes the minimal functionality that a plug-in must implement. 
 * 
 * @author costing
 * @since Oct 20, 2008
 * @see leds.modules.BaseModule
 */
public interface Module {

	/**
	 * Load configuration options
	 * 
	 * @param config configuration holder
	 * @param xStart x starting coordinates
	 * @param yStart y starting coordinates
	 */
	public void init(ExtProperties config, int xStart, int yStart);
	
	/**
	 * Put the information on the canvas
	 *
	 * @param c Canvas to draw on
	 * @return true if the module executed successfully and drew something on the display, false if there was an error/nothing was displayed
	 */
	public boolean draw(Canvas c);
	
	/**
	 * What are the dimensions of what is displayed?
	 * 
	 * @return width of the output
	 */
	public int getWidth();
	
	/**
	 * What is the height of the displayed area ?
	 * 
	 * @return height of the output
	 */
	public int getHeight();
	
}
