/**
 * 
 */
package leds.modules;

import leds.ExtProperties;
import leds.Module;

/**
 * A simple skeleton for all the modules. All need some positioning and some need the width and height too.
 * 
 * @author costing
 * @since Oct 20, 2008
 */
public abstract class BaseModule implements Module{
	/**
	 * What is the height of the text, save it for {@link #getHeight()}
	 */
	int height = 0;
	
	/**
	 * Cache width
	 */
	int width = 0;
	
	/**
	 * X starting coordinates
	 */
	int x = 0;
	
	/**
	 * Y starting coordinates
	 */
	int y = 0;
	
	/* (non-Javadoc)
	 * @see leds.Module#getHeight()
	 */
	@Override
	public int getHeight() {
		return this.height;
	}

	/* (non-Javadoc)
	 * @see leds.Module#getWidth()
	 */
	@Override
	public int getWidth() {
		return this.width;
	}

	/* (non-Javadoc)
	 * @see leds.Module#init(leds.ExtProperties, int, int)
	 */
	@Override
	public void init(final ExtProperties config, final int xStart, final int yStart) {
		this.x = xStart;
		this.y = yStart;
	}	
}
