/**
 * 
 */
package leds.modules;

import leds.Canvas;
import leds.Utils;
import leds.Values;

/**
 * Display the CPU cores' operating frequencies. The information is extracted from either 
 * /sys/devices/system/cpu/cpuN/cpufreq/scaling_cur_freq or /proc/cpuinfo.
 * 
 * @author costing
 * @since Oct 20, 2008
 * @see Utils#getCPUFreq()
 */
public class CPUFreq extends BaseModule {
	
	/* (non-Javadoc)
	 * @see leds.Module#draw(leds.Canvas, int, int)
	 */
	@Override
	public boolean draw(final Canvas c) {
		if (this.height==0)
			this.height = c.getTextHeight() - 2;

		if (this.width==0)
			this.width=100;
		
		final Values v = Utils.getCPUFreq();

		String s = ""; //$NON-NLS-1$

		for (double d : v.values()) {
			s += (s.length() > 0 ? "|" : "") + ((int) d / 100) * 100; //$NON-NLS-1$//$NON-NLS-2$
		}
		
		c.drawString(s, this.x+this.width, this.y+this.height, Canvas.ALIGN_RIGHT);
		
		return true;
	}
}
