#!/bin/bash

export WHEREAMI=`cd $(dirname $0); pwd`

source "$WHEREAMI/functions"

for pid in `pgrep dbus-daemon`; do
    if [ ! -r /proc/$pid/environ ]; then
	continue
    fi

    user=`stat -c %U /proc/$pid/environ`

    eval "dir=~$user"
    
    if [ ! -d "$dir" -o ! -r "$dir" -o ! -x "$dir" ]; then
	continue
    fi
    
    file=`grep -l "DBUS_SESSION_BUS_PID=$pid" ${dir}/.dbus/session-bus/* 2>/dev/null`
    
    if [ -z "$file" ]; then
	continue
    fi
    
    ID=`grep "^DBUS_SESSION_BUS_ADDRESS=" "$file"`

    export $ID
    
    if [ "$IAM" = "$user" ]; then
	apps=`$QDBUS | grep "^ "`
    else
	apps=`su $user -c "$QDBUS | grep \"^ \""`
    fi
    
    for app in $apps; do
	echo "$user $DBUS_SESSION_BUS_ADDRESS $app"
    done
done
